#ifndef MSGSERVER_HH
#define MSGSERVER_HH

#include <map>

#include "iserver.hh"
#include "message.hh"
#include "msgConstants.hh"

class msgServer {

	private:
		iserver iserv;
		unsigned int currentPort;
		bool isRunning;
		bool isMessagesWaiting;
		unsigned int inactivity_time;
		std::map<int, std::string> clients;
		
		typedef std::map<int, std::string> clientList;
		clientList::iterator find(const clientList::iterator& begin, const clientList::iterator& end, const std::string& name){
			clientList::iterator it=begin;
			std::cout<<"Find : "<<name<<std::endl;
			while(it!=end){
				std::cout<<"\tCompare to "<<it->second<<std::endl;
				if(it->second==name){
					return it;
				}
			}
			return it;
		}
		
	public:
		msgServer(unsigned int port = DEFAULT_SERVER_PORT, unsigned int inact = DEFAULT_SERVER_INACTIVITY_TIME);
		~msgServer();
		void run();
		void addConnection(int c, std::string n);
		void removeConnection(int c);
		void setInactivityTime(unsigned int inact);
		bool isConnected(std::string c);
		void manageIncomingMessage(int c, message m);
		void sendTo(std::string dest, std::string m);
		void shutdown();
		
};

#endif
